/*
//
// BEGIN SONGBIRD GPL
//
// This file is part of the Songbird web player.
//
// Copyright(c) 2005-2008 POTI, Inc.
// http://songbirdnest.com
//
// This file may be licensed under the terms of of the
// GNU General Public License Version 2 (the "GPL").
//
// Software distributed under the License is distributed
// on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either
// express or implied. See the GPL for the specific language
// governing rights and limitations.
//
// You should have received a copy of the GPL along with this
// program. If not, go to http://www.gnu.org/licenses/gpl.html
// or write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
//
// END SONGBIRD GPL
//
*/


if (typeof Cc == 'undefined') var Cc = Components.classes;
if (typeof Ci == 'undefined') var Ci = Components.interfaces;
if (typeof Cu == "undefined") var Cu = Components.utils;
if (typeof Cr == 'undefined') var Cr = Components.results;

/* global variables -------------------------------------------------------*/
var daapLibManager = null;



/* get a pointer to the global tab browser */
if (typeof(gBrowser) == "undefined") {
  var gBrowser =  Cc["@mozilla.org/appshell/window-mediator;1"]  
                  .getService(Ci.nsIWindowMediator)  
                  .getMostRecentWindow("Songbird:Main").window.gBrowser;
}  

/* Make sure we have the javascript modules we're going to use */
if (typeof(XPCOMUtils) == "undefined") {
  Cu.import("resource://gre/modules/XPCOMUtils.jsm");
  if (!XPCOMUtils)
    throw new Error("Import of XPCOMUtils module failed!");
}
if (typeof(DProperty) == "undefined") {
  Components.utils.import("resource://daapclient/DaapProperties.jsm");
  if (!DProperty)
    throw new Error("Import of DProperty module failed!");
}

/**
 * Fill the local library with remote tracks
 */

var DaapLoadTracks = {

  /* nsISupports ----------------------------------------------------------*/
  QueryInterface: XPCOMUtils.generateQI([Ci.sbIServiceListener]),

  /* private data ---------------------------------------------------------*/
  browser: null,

  /* initialize -----------------------------------------------------------*/
  init: function ()
  {
    if (!(daapLibManager instanceof Ci.sbIDaapLibraryManager)) {
      daapLibManager = Cc["@songbirdnest.com/daap/library-manager;1"]
                        .getService(Ci.sbIDaapLibraryManager);
    }


    this.browser = gBrowser.getBrowserAtIndex(0);
    if (this.browser) {
      this.browser.addEventListener("DOMContentLoaded", this.onLoad, false);
    }
  },

  /* shutdown -------------------------------------------------------------*/
  shutdown: function ()
  {
    if (this.browser) {
      this.browser.removeEventListener("DOMContentLoaded", this.onLoad, false);
    }    
  },


  /* private functions ----------------------------------------------------*/

  /*
   * This is the event listener for DOMContentLoaded.
   * It's called every time a page is loaded in the browser.
   *
   **/
  onLoad: function (e)
  {
    if (gBrowser.currentMediaListView) {
      let mediaList = gBrowser.currentMediaListView.mediaList;

      let databaseId = mediaList.library.getProperty(DProperty.databaseId);
      if (databaseId) {
        // XXXDaniel use timeout here to let the meadiatab finish loading
        setTimeout(function() { daapLibManager.open(mediaList); }, 0);
      }
    }
  },

}; //DaapLoadTracks



/**
 * Display debug messages and stats
 *
 **/
/*
if (typeof(DaapDebug) == 'undefined') {

  function DaapDebug(aMessage, aStart) {

    if (aStart) {
      var elapsed = Date.now() - aStart;
      var time = (elapsed / 1000);
      aMessage += " (time: " + time + ")";
    }

    var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage("[Daap Client] " + aMessage);
  }  
}
*/

    

